// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ScollBarDemo.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_PLAY, OnPlay)
	ON_UPDATE_COMMAND_UI(ID_PLAY, OnUpdatePlay)
	ON_COMMAND(IDC_BUTTON, OnPress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndStatusBar.SetPaneStyle(0,WS_DLGFRAME|SBPS_STRETCH);
	m_wndStatusBar.SetPaneInfo(1,ID_SEPARATOR,SBPS_NORMAL,80);
	SetWindowText(_T("(Netscape) Scrolled Bar Demo - Amir Israeli"));
	
	// creating the window that will be inserted to pane :
	// on the stack : (a progress bar + also activates it)
	prg.Create(ID_PROGRESS,this,CRect(0,0,0,0),TRUE);
	prg.Play();
prg.SetWindowText("hello to you");

	// creating 2 additional controls as more examples
	m_wndEdit.Create(ES_LEFT|WS_CHILD|WS_VISIBLE,CRect(0,0,1,1),this,IDC_COMBO);
	m_wndButton.Create(_T("Try"),BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE,CRect(0,0,1,1),this,IDC_BUTTON);


	/* This is the most importent part : creating the StatusBar hook 
	and add windows to status bar (pane 1,2,3) : windows that previously 
	created : 4 lines and job is done !!!
	The object is supply a self contained windows in order to lighten and
	shorten the implementation of CFrameWnd derived class : a good example for
	a self contained window is CProgress */
	m_statusWndIns.SetStatusBar(&m_wndStatusBar);
	m_statusWndIns.AddWindow(&prg,1);
	m_statusWndIns.AddWindow(&m_wndEdit,2);
	m_statusWndIns.AddWindow(&m_wndButton,3);


	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	cs.style &= ~FWS_ADDTOTITLE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnPlay() 
{
	(prg.IsPlaying()) ? prg.Pause() : prg.Play();
}
void CMainFrame::OnPress() 
{
	CRect rc;
	m_wndStatusBar.GetWindowRect(&rc);
	int nHeight = rc.Height() + 1;
	if (nHeight<50) {
		m_wndStatusBar.GetStatusBarCtrl().SetMinHeight(nHeight);
		DelayRecalcLayout();
	}
}
void CMainFrame::OnUpdatePlay(CCmdUI* pCmdUI) 
{
	BOOL bPlaying = prg.IsPlaying();
	pCmdUI->SetCheck(bPlaying);
	(bPlaying) ? pCmdUI->SetText(_T("Pause")) :
		pCmdUI->SetText(_T("Play"));
}
