#if !defined(AFX_PROGRESS_H__2DA91E6B_EFEE_11D4_B808_B8C8C3EEAE1B__INCLUDED_)
#define AFX_PROGRESS_H__2DA91E6B_EFEE_11D4_B808_B8C8C3EEAE1B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Progress.h : header file
//

/* Written by Amir Israeli January 2000,
   You may use this class , modify it , but dont remove this header.
   israelaq@wall.co.il  www.amir-israeli.tripod.com */

/////////////////////////////////////////////////////////////////////////////
// CProgress window

class CProgress : public CWnd
{
public:
	CProgress();
	virtual ~CProgress();

	BOOL Create(UINT nID,CWnd *pParent,RECT &rc,BOOL bAllowResize=FALSE,COLORREF clrBK=::GetSysColor(COLOR_3DFACE));
	BOOL CreateFromStatic(UINT nID,CWnd *pParent,BOOL bAllowResize=FALSE,COLORREF clrBK=::GetSysColor(COLOR_3DFACE));

	void SetBar(RECT &rc,int nWidth=0);
	// returns the last color being set
	COLORREF SetColor(COLORREF clr,BOOL bAddBrightness=TRUE);
	enum { CLR1=0x8F696AC7 , CLR2=0xAFFD779C , CLR3=0x947EC477 , CLR4=0x8F57BCD9 , CLR5=0xAA808080 };
	
	void SetFadeEffect(BOOL bSet) { m_bUseFadeEffect = bSet; }
	BOOL GetFadeEffect() { return m_bUseFadeEffect; }

	BOOL Play();
	BOOL Pause();
	int SetFrequency(int nFrequency=60);
	BOOL IsPlaying() { return this->m_bPlaying; }

	// returns TRUE if text will be shown (FALSE if not) : a proposed 
	//format is "Done %d\%" this will also set m_bShowText to TRUE
	BOOL SetTextFormat(LPCTSTR lpsz);
	// sets position (percentage)
	BOOL SetProgressPosition(int nPos,BOOL bShowText=TRUE);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProgress)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CProgress)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg LRESULT OnSetText(WPARAM wp, LPARAM lp);
	DECLARE_MESSAGE_MAP()

protected:
	UINT m_nTimerID;
	int  m_nFrequency;
	BOOL m_bPlaying;

	void PaintBarArea(CDC &dc,int x,int y,int w,int h,COLORREF color);
	void PaintBar(CDC &dc,LPCTSTR lpszTitle);

	BOOL Step();
	int GetPosition() const {	return m_nPosition; }
	int m_nPosition;

	enum { UP = 1, DOWN = 2 };
	int GetDirection() { return m_nDirection; }
	int SetDirection(int nDirection=UP);
	int m_nDirection; //1=up 2=down

	BOOL m_bShowText; // show text or not
	CString strTextFormat; // format of text to show on window
	int m_nProgressPosition; // % progress so far
	void DrawMyText(CDC &dc);
	int GetLuminosity(COLORREF clr);
protected:

	CBrush m_brush;
	CRect rcBar;
	int m_nWidth;
	BOOL m_bUseFadeEffect;

	// if resize is allowed then the bar is resized to the size of the 
	// window whenever the window is resized (useful for dynamicly changing bars)
	BOOL m_bAllowResize;

	static int NCOLORSHADES;// 64
	static int MOVEMENT;//2
	static int HLSMAX; //240 This is what Display Properties uses
	static int RGBMAX; // max r/g/b value is 255
	static int LUMINOSITY_MARK; //120 
	COLORREF clrFG,clrBK;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROGRESS_H__2DA91E6B_EFEE_11D4_B808_B8C8C3EEAE1B__INCLUDED_)
